#include <STDIO.H>
#include <STDLIB.H>
#include <STRING.H>
#include <DOS.H>
#include <CONIO.H>


unsigned char FLevel[6401];
	 int  FBlink = 128;
	 int  FEnemyColor;
	 int  FFloorColor;
	 int  FWaterColorIndex = 0;


void waitForKeyPress(void) {
  printf("Press any key to continue...\n\n");

  asm {
    xor ax, ax;
    int 0x16;
  }
}


void loadLevel(char* AFilename) {
  FILE* loadFile;

  loadFile = fopen(AFilename, "rb");
  if (loadFile == NULL) {
    printf("Can't find %s!\n", AFilename);
    waitForKeyPress();
    exit(EXIT_FAILURE);
  }

  fread(FLevel, 6401, 1, loadFile);
  fclose(loadFile);
}


void convertMap(void) {
	   int  i, j;
  unsigned char buffer[6401];
  unsigned char c;

  i = 0;
  j = 0;
  while (j < 6401) {
    c = FLevel[i];

    if (c & 128) {
      c &= 127;
    }
    else if (c == 8) {
      c = '*';
    }

    if ((c == 10) && (buffer[j-1] != 13)) {
      buffer[j] = 13;
      j++;
    }
    buffer[j] = c;

    i++;
    j++;
  }

  buffer[6399] = 26;
  buffer[6400] = 26;

  for (i = 0; i < 6401; i++) {
    FLevel[i] = buffer[i];
  }
}


void saveLevel(char* AFilename) {
  FILE* saveFile;

  saveFile = fopen(AFilename, "wb");

  fwrite(FLevel, 6401, 1, saveFile);
  fclose(saveFile);
}


int hasThorBeast(void) {
  //Bounded Linear Search

  int p, q;

  p = 0;
  q = 6401;
  while (p != q) {
    if (FLevel[p] == 't') {
      q = p;
    }
    else {
      p++;
    }
  }

  return (p < 6401);
}


void calculateFloorColor(void) {
  FFloorColor = (hasThorBeast() ? 4 : 8);
}


void calculateEnemyColor(char* AFilename) {
  char c;
  int  l;

  l = strlen(AFilename);
  c = AFilename[l - 5];

  switch (c) {
    case 'a': case 'A': FEnemyColor = 14; break;
    case 'b': case 'B': FEnemyColor =  1; break;
    case 'c': case 'C': FEnemyColor =  2; break;
    case 'd': case 'D': FEnemyColor =  3; break;
    case 'e': case 'E': FEnemyColor =  6; break;
    case 'f': case 'F': FEnemyColor =  8; break;
    case 'g': case 'G': FEnemyColor =  5; break;
    case 'h': case 'H': FEnemyColor =  4; break;
    case 'i': case 'I': FEnemyColor =  4; break;
    default:            FEnemyColor =  4; break;
  }
}


int getWaterColor(void) {
  int foregroundColor;
  int waterColor[] = {15, 7, 11, 3, 9, 1, 9, 3, 11, 7};

  foregroundColor = waterColor[FWaterColorIndex];
  FWaterColorIndex = (FWaterColorIndex + 1) % 10;

  return (foregroundColor + 1 * 16);
}


void setScreenMode(void) {
  asm {
    mov ax, 4;
    int 0x10;
    mov ax, 3;
    int 0x10;
  }
}


void setExitScreenMode(void) {
  asm {
    mov ax, 3;
    int 0x10;
  }
}


void drawChar(int AX, int AY, unsigned char AC) {
  unsigned char c, k;

  if ((65 <= AC) && (AC <= 90)) { c = AC & 127; k = 15; } //Capital letters
  else if (AC == '!') { c =  AC; k = 15; }                //!
  else if (AC == '/') { c =  AC; k = 14; }                // /
  else if (AC == ' ') { c = 176; k = FFloorColor; }       //Floor
  else if (AC == '*') { c = 219; k =  8; }                //Unbreakable brick
  else if (AC == 'u') { c = 178; k =  8; }                //Breakable brick
  else if (AC == '-') { c = 205; k =  8; }                //Horizontal door
  else if (AC == '|') { c = 186; k =  8; }                //Vertical door
  else if (AC == '1') { c = '.'; k = 14 + 4 * 16; }       //Lava
  else if (AC == '2') { c = 250; k = 14 + 4 * 16; }       //Lava
  else if (AC == '3') { c = 249; k = 14 + 4 * 16; }       //Lava
  else if (AC == '4') { c = 248; k = 14 + 4 * 16; }       //Lava
  else if (AC == 'e') { c =   2; k = FEnemyColor; }       //Enemy
  else if (AC == '#') { c = '*'; k =  7; }                //Enemy maker
  else if (AC == '@') { c =   6; k =  2; }                //Food
  else if (AC == ')') { c =  AC; k = 15 + 1 * 16; }       //Shield
  else if (AC == 's') { c = ')'; k = 15 + 1 * 16; }       //Shield
  else if (AC == '.') { c = 177; k =  2; }                //Grass
  else if (AC == ',') { c =  31; k = getWaterColor(); }   //Water down
  else if (AC == '^') { c =  30; k = getWaterColor(); }   //Water up
  else if (AC == '>') { c =  16; k = getWaterColor(); }   //Water left
  else if (AC == '<') { c =  17; k = getWaterColor(); }   //Water right
  else if (AC == '0') { c =  AC; k = 14; }                //Coin
  else if (AC == 'i') { c =  AC; k = 14 + 7 * 16; }       //Candlelight
  else if (AC == 'p') { c = 235; k =  5; }                //Potion
  else if (AC == 'r') { c =  26; k = 15; }                //Rebounder
  else if (AC == 'k') { c = 244; k = 14; }                //Key
  else if (AC == '?') { c =  AC; k =  0 + 7 * 16; }       //Mystery
  else if (AC == 'h') { c =   3; k =  4 + FBlink; }       //Heart
  else if (AC == 'm') { c =  11; k =  1 + FBlink; }       //Male
  else if (AC == 'f') { c =  12; k = 12 + FBlink;}        //Female
  else if (AC == 't') { c = 185; k = 14; }                //Thor beast
  else if (AC == 'a') { c = 222; k =  6; }                //Temporary confuser
  else if (AC == 'w') { c = 242; k =  1 + 2 * 16; }       //Food limit increaser
  else if (AC == '~') { c = 206; k = 14 + 4 * 16; }       //Breakway
  else if (AC == 'o') { c = 'o'; k =  9 + 1 * 16; }       //Outside
  else { c = AC; k = 12 + 3 * 16 + 128; }                 //UNKNOWN

  pokeb(0xB800, AY * 2 * 80 + AX + AX, c);
  pokeb(0xB800, AY * 2 * 80 + AX + AX + 1, k);
}


void drawWindow(int AWindowX, int AWindowY) {
  int x, y;

  for (y = 0; y < 25; y++) {
    for (x = 0; x < 79; x++) {
      drawChar(x, y, FLevel[AWindowY*81+y*81+AWindowX+x]);
    }
  }
}


void processInput(void) {
  //windowX is used when the width of the level is more than
  //the width of the screen.
  //In the current version of this program this is not used.
  int windowX = 0;
  int windowY = 0;
  int c;
  int extended = 0;
  int quit;

  quit = 0;
  while (!quit) {
    drawWindow(windowX, windowY);

    c = getch();
    if (!c) {
      extended = getch();
    }

    if ((c == 27) || (c == 'q') || (c == 'Q')) {
      quit = -1;
    }
    else if ((c == 'b') || (c == 'B')) {
      FBlink = 128 - FBlink;
    }
    else if ((c == 'd') || (c == 'D')) {
      saveLevel("outmap.txt");
    }
    else if (!c && (extended == 'P')) { //Down
      windowY++;
    }
    else if (!c && (extended == 'H')) { //Up
      windowY--;
    }
    else if (!c && (extended == 'I')) { //PgUp
      windowY -= 24;
    }
    else if (!c && (extended == 'Q')) { //PgDn
      windowY += 24;
    }
    else if (!c && (extended == 'M')) { //Left
      windowX++;
    }
    else if (!c && (extended == 'K')) { //Right
      windowX--;
    }
    else if (!c && (extended == 'G')) { //End
      windowX -= 79;
    }
    else if (!c && (extended == 'O')) { //Home
      windowX += 79;
    }

    if (windowY < 0) {
      windowY = 0;
    }
    else if ( 54 < windowY) {
      windowY = 54;
    }

    if (windowX < 0) {
      windowX = 0;
    }
    else if (0 < windowX) {
      windowX = 0;
    }
  }
}


int main(int argc, char* argv[]) {
  printf("The Thor Trilogy level viewer by Frenkel, 20-Jul-2008.\n");
  waitForKeyPress();

  if (argc < 2 ) {
    printf("Usage: THORLEV $FILENAME$, where $FILENAME$ is the name of the level file.\n");
    waitForKeyPress();
    return -1;
  }

  loadLevel(argv[1]);
  convertMap();
  calculateFloorColor();
  calculateEnemyColor(argv[1]);
  setScreenMode();
  processInput();
  setExitScreenMode();

  return 0;
}